#
# control script
# running R scripts for DWD Weste time series analysis 
# not optimized for performance !!
#-----------------------------------------
# set the system environment to English -> personal notebook has German UI 
Sys.setlocale("LC_TIME", "English") # Windows

# general part: preparating work environment: reading data and functions 
# reading time series
source("DWDFile_InputOutput.R")
# operational functions
source("DWDFile_ManagementFunctions.R")
# analysis functions
source("DWDFile_AnalysisFunctions.R")
# plot functions
source("DWDFile_PlotFunctions.R")


#-------------------------------------------------------------
# specific part to perform time series management and analysis
# general time series features and gap check
if(FALSE)
{
 print(paste("Air Temperature:  min",min(ts_air_temperature[,2])))
 print(paste("                  max",max(ts_air_temperature[,2])))
 print(paste("                  mean",mean(ts_air_temperature[,2])))
 check_gaps(ts_air_temperature,3600)

 print(paste("Soil Temperature: min",min(ts_soil_temperature[,2])))
 print(paste("                  max",max(ts_soil_temperature[,2])))
 print(paste("                  mean",mean(ts_soil_temperature[,2])))
 check_gaps(ts_soil_temperature,3600)

 print(paste("Precipitation:    min",min(ts_precipitation[,2])))
 print(paste("                  max",max(ts_precipitation[,2])))
 print(paste("                  sum",sum(ts_precipitation[,2])))
 check_gaps(ts_precipitation,3600)
}

#
# general monthly time series features
#
# function to print monthly key values
#
printMonthlyValues <- function(title,time_series,mean)
{
 title_text="                  month"
 min_text   = paste(title,"min  ")
 max_text   ="                  max  "
 if(mean==TRUE)mean_text  ="                  mean "
 else          mean_text  ="                  sum  "
 # loop on all months
 for(i in 1:12) 
  { title_text = paste(title_text,sprintf("    %2d",i))
    month_time_series = extract_month_subset(time_series,i)
    min_text  = paste(min_text,sprintf("%6.2f",min(month_time_series[,2])))
    max_text  = paste(max_text,sprintf("%6.2f",max(month_time_series[,2])))
    if(mean==TRUE){
    mean_text = paste(mean_text,sprintf("%6.2f",mean(month_time_series[,2])))  }
    else {
    mean_text = paste(mean_text,sprintf("%6.2f",sum(month_time_series[,2])))  }
 }
# print the results line by line 
 print(title_text)
 print(min_text)
 print(max_text)
 print(mean_text)
}

#
# print monthly key values in a table for all three time series
#
if(FALSE)
{
 printMonthlyValues("Air Temperature: ",ts_air_temperature,mean=TRUE)
 printMonthlyValues("Soil Temperature:",ts_soil_temperature,mean=TRUE)
 printMonthlyValues("Precipitation:   ",ts_precipitation,mean=FALSE)
}

#
#--------------------------------------------------------------------------- 
# plotting part
# 
# plot time series for one year

plot_year(ts_air_temperature,"Ta")
#plot_year(ts_soil_temperature,"Ts")
#plot_year(ts_precipitation,"P")

#
# plot monthwise
# 
# plot air temperature in April and July
#plot_month(ts_air_temperature,4,"Ta")
#plot_line_month(ts_air_temperature,7)

#
# comparison of soil and air temperature
#
plot_month(ts_soil_temperature,10,"Ts")
plot_line_month(ts_air_temperature,10)

# month time series precipitation
#
#plot_month(ts_precipitation,7,"P")

# plot the scaled daily and weekly time series
# air temperature
if(FALSE)
{
ts  = ts_air_temperature
ts1 = scaleTimeSeries(ts,24,mean=TRUE)
ts2 = scaleTimeSeries(ts,24*7,mean=TRUE)
plot(ts,type="l",col="lightgreen")
lines(ts1,col="darkblue")
lines(ts2,col="red")
}
# precipitation - > summing up instead of mean value
if(FALSE)
{
ts  = ts_precipitation
ts1 = scaleTimeSeries(ts,24,mean=FALSE)
ts2 = scaleTimeSeries(ts,24*7,mean=FALSE)
plot(ts,type="S",col="lightgreen",ylim=c(0,100))
lines(ts1,type="S",col="darkblue")
lines(ts2,type="S",col="red")
}


