#
# reading DWD Weste-XL files
#
# reading using read.table and read csv
# DWD files with hourly data for one year
# extracting data by columns
# convert to time data types
#-----------------------------------------------

#
# reading files 
#
ts_air_temperature  <- read.csv("weste_product_2010_air_temperature.csv",header = T, sep = ";", quote = "", dec = ",")
ts_soil_temperature <- read.csv("weste_product_2010_soil_temperature.csv",header = T, sep = ";", quote = "", dec = ",")
ts_precipitation    <- read.csv("weste_product_2010_precipitation.csv",header = T, sep = ";", quote = "", dec = ",")

#
# reduction to relevant columns 3 for time and 4 for scalar value
#
ts_air_temperature  = subset(ts_air_temperature[,3:4])
ts_soil_temperature = subset(ts_soil_temperature[,3:4])
ts_precipitation    = subset(ts_precipitation[,3:4])

#
# convert first column to time values 
#
ts_air_temperature[,1]  <- as.POSIXct(ts_air_temperature[,1],tz="UTC")
ts_soil_temperature[,1] <- as.POSIXct(ts_soil_temperature[,1],tz="UTC")
ts_precipitation[,1]    <- as.POSIXct(ts_precipitation[,1],tz="UTC")


